//+------------------------------------------------------------------+
//|                                              VininI_MACD_MTF.mq4 |
//|                     Copyright  2011, Victor Niclolaev aka Vinin |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Victor Niclolaev aka Vinin"
#property link      "vinin@mail.ru"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 Red
#property indicator_color4 Yellow
#property indicator_width3 2
#property indicator_width4 2
#property indicator_level1 0

//--- input parameters
extern int       TimeFrame1=0;          //  
extern int       FastEma1=12;           
extern int       SlowEma1=26;
extern int       SignalSMA1=9;
extern int       price1=PRICE_CLOSE;

extern int       TimeFrame2=0;          //  
extern int       FastEma2=12;           
extern int       SlowEma2=26;
extern int       SignalSMA2=9;
extern int       price2=PRICE_CLOSE;

extern bool      RedRaw=false;         //          
//--- buffers
double MACD1[];
double SIGNAL1[];
double MACD2[];
double SIGNAL2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MACD1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,SIGNAL1);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,MACD2);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,SIGNAL2);


   if (TimeFrame1<Period()) TimeFrame1=Period();
   if (TimeFrame2<Period()) TimeFrame2=Period();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int  i,  pos, counted_bars=IndicatorCounted();
   int limit=Bars-counted_bars-1;
   
   if (RedRaw && !(limit>1)) 
   {
      limit=MathMax(iBarShift(NULL, 0, iTime(NULL, TimeFrame1, 1), true),iBarShift(NULL, 0, iTime(NULL, TimeFrame2, 1), true));
   }
   for (i=limit;i>=0;i--) {
      pos=iBarShift(NULL, TimeFrame1, Time[i], true);
      MACD1[i]  =iMACD(NULL, TimeFrame1, FastEma1, SlowEma1, SignalSMA1, price1, MODE_MAIN,   pos);
      SIGNAL1[i]=iMACD(NULL, TimeFrame1, FastEma1, SlowEma1, SignalSMA1, price1, MODE_SIGNAL, pos);

      pos=iBarShift(NULL, TimeFrame2, Time[i], true);
      MACD2[i]  =iMACD(NULL, TimeFrame2, FastEma2, SlowEma2, SignalSMA2, price2, MODE_MAIN,   pos);
      SIGNAL2[i]=iMACD(NULL, TimeFrame2, FastEma2, SlowEma2, SignalSMA2, price2, MODE_SIGNAL, pos);

   }

   return(0);
  }
//+------------------------------------------------------------------+